function varargout = gui_modis(varargin)
% Boots-up MODIS GUI, interacts with user via interface.
% gui_modis M-file for gui_modis.fig
%
% INPUT(S):
%
%   [none]
%
% OUTPUT(S):
%
%   h -- (optional) GUI handle
%
% Meri Sheremet
% June 2007

warning('off','MATLAB:dispatcher:InexactMatch');
% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_modis_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_modis_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT
warning('on','MATLAB:dispatcher:InexactMatch');

% --- Executes just before gui_modis is made visible.
function gui_modis_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to gui_modis (see VARARGIN)

% Define handles "openfigure" field.
if ~isfield(handles,'openfigure')
    handles.openfigure = 0; %set equal to zero on the first time.
end

% Set interface name.
txt = ['NASA/REASoN Ocean Data Portal - '];
tmp1 = ['MODIS GUI'];
tmp2 = strrep(op_version('mfile',strrep(mfilename,'gui','get')),'Version ','');
txt = [txt,tmp1,' (Ver ',tmp2,')'];
set(hObject,'Name',txt);

% Set "SaveFiles" off. (THIS IS TEMPORARY ... 08 MAY 2007)
set(handles.radiobutton2,'Enable','Off');

% Set Version Number.
filename = strrep(mfilename,'gui','get');
info = op_version(filename);
set(handles.text2,'String',info);

% default GUI settings

scale_factor = 0.8300;

[img,MAP]=imread('logo_opendap.jpg');
set(handles.pushbutton3,'CData',img)
if ~handles.openfigure
    if strcmpi(computer,'maci') || strcmpi(computer,'mac')
    pos = get(handles.pushbutton3,'position'); %units will be in characters
    set(handles.pushbutton3,'position',[pos(1),pos(2),scale_factor*pos(3),pos(4)]);
    end
end

[img,MAP]=imread('logo_nasa_jpl.jpg');
set(handles.pushbutton4,'CData',img)
if ~handles.openfigure
    if strcmpi(computer,'maci') || strcmpi(computer,'mac')
    pos = get(handles.pushbutton4,'position'); %units will be in characters
    set(handles.pushbutton4,'position',[pos(1),pos(2),scale_factor*pos(3),pos(4)]);
    end
end

if get(handles.radiobutton1,'Value')==0 & get(handles.radiobutton2,'Value')==0
set(handles.radiobutton1,'Value',1)
end

if get(handles.radiobutton2,'Value') == 0
    set(handles.edit13,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
    set(handles.edit14,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
elseif get(handles.radiobutton2,'Value') == 1
    set(handles.edit13,'BackgroundColor',[1. 1. 1.],'Enable','On')
    set(handles.edit14,'BackgroundColor',[1. 1. 1.],'Enable','On')
end

set(handles.pushbutton1,'String','Get Data')

% set time range 
set(handles.text7,'String','Available time range: [2000-02-24 to 2006-05-08]')

% Choose default command line output for gui_modis
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes gui_modis wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = gui_modis_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

function checkbox1_Callback(hObject, eventdata, handles)
function checkbox2_Callback(hObject, eventdata, handles)
function checkbox3_Callback(hObject, eventdata, handles)
function checkbox4_Callback(hObject, eventdata, handles)
function checkbox5_Callback(hObject, eventdata, handles)
function checkbox6_Callback(hObject, eventdata, handles)
function checkbox7_Callback(hObject, eventdata, handles)
function checkbox8_Callback(hObject, eventdata, handles)

function edit1_CreateFcn(hObject, eventdata, handles)
function edit1_Callback(hObject, eventdata, handles)
function edit2_CreateFcn(hObject, eventdata, handles)
function edit2_Callback(hObject, eventdata, handles)
function edit3_CreateFcn(hObject, eventdata, handles)
function edit3_Callback(hObject, eventdata, handles)
function edit4_CreateFcn(hObject, eventdata, handles)
function edit4_Callback(hObject, eventdata, handles)
function edit5_CreateFcn(hObject, eventdata, handles)
function edit5_Callback(hObject, eventdata, handles)
function edit6_CreateFcn(hObject, eventdata, handles)
function edit6_Callback(hObject, eventdata, handles)
function edit7_CreateFcn(hObject, eventdata, handles)
function edit7_Callback(hObject, eventdata, handles)
function edit8_CreateFcn(hObject, eventdata, handles)
function edit8_Callback(hObject, eventdata, handles)
function edit9_CreateFcn(hObject, eventdata, handles)
function edit9_Callback(hObject, eventdata, handles)
function edit10_CreateFcn(hObject, eventdata, handles)
function edit10_Callback(hObject, eventdata, handles)

function popupmenu1_CreateFcn(hObject, eventdata, handles)
function popupmenu1_Callback(hObject, eventdata, handles)
function popupmenu2_CreateFcn(hObject, eventdata, handles)
function popupmenu2_Callback(hObject, eventdata, handles)

function radiobutton3_Callback(hObject, eventdata, handles)
function radiobutton4_Callback(hObject, eventdata, handles)
function radiobutton5_Callback(hObject, eventdata, handles)
function radiobutton6_Callback(hObject, eventdata, handles)

function edit11_CreateFcn(hObject, eventdata, handles)
function edit11_Callback(hObject, eventdata, handles)
function edit12_CreateFcn(hObject, eventdata, handles)
function edit12_Callback(hObject, eventdata, handles)
function edit13_CreateFcn(hObject, eventdata, handles)
function edit13_Callback(hObject, eventdata, handles)
function edit14_CreateFcn(hObject, eventdata, handles)
function edit14_Callback(hObject, eventdata, handles)
function edit15_Callback(hObject, eventdata, handles)
function edit15_CreateFcn(hObject, eventdata, handles)

function radiobutton1_Callback(hObject, eventdata, handles)
function radiobutton2_Callback(hObject, eventdata, handles)
SaveFilesOnOff(hObject, eventdata, handles)

function popupmenu3_Callback(hObject, eventdata, handles)
function popupmenu3_CreateFcn(hObject, eventdata, handles)

function pushbutton2_Callback(hObject, eventdata, handles)
if get(handles.radiobutton2,'Value') == 1
DIRNAME=uigetdir(pwd,'Select a Directory for Downloading Files');
set(handles.edit13,'String',DIRNAME)
end

% The main button that starts data acquisition
function pushbutton1_Callback(hObject, eventdata, handles)
%% Turn off ability to re-issue "Get Data."
set(hObject,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off','String','Please wait...');
pause(.1)

%% GET INPUT FROM GUI 
request=InputGet(hObject, eventdata, handles);

%% Remember request.
pname = strrep(mfilename('fullpath'),mfilename,'');
fname = [mfilename,'_request','.mat'];
save([pname,fname],'request','-mat')

% If it passes inspection, send down to user's workspace
% as variable "request". Then the user can get the data
assignin('base','request',request);

get_modis(request);

set(hObject,'Enable','On','String','Get Data','BackgroundColor',[0 1. 0.25]);

function pushbutton3_Callback(hObject, eventdata, handles)
web 'http://www.opendap.org/' -browser
function pushbutton4_Callback(hObject, eventdata, handles)
web 'http://podaac.jpl.nasa.gov:2031/DATASET_DOCS/modis_sst.html' -browser

function request=InputGet(hObject, eventdata, handles)
S1=deblank(get(handles.edit1,'String'));
S2=deblank(get(handles.edit2,'String'));
S3=deblank(get(handles.edit3,'String'));
S4=deblank(get(handles.edit4,'String'));
S5=deblank(get(handles.edit5,'String'));
S6=deblank(get(handles.edit6,'String'));

DATE1='00000000';
DATE1(4-length(S1)+1:4)=S1;
DATE1(6-length(S2)+1:6)=S2;
DATE1(8-length(S3)+1:8)=S3;
DATE2='00000000';
DATE2(4-length(S4)+1:4)=S4;
DATE2(6-length(S5)+1:6)=S5;
DATE2(8-length(S6)+1:8)=S6;

LAT1=str2num(deblank(get(handles.edit7,'String')));
LAT2=str2num(deblank(get(handles.edit8,'String')));
LON1=str2num(deblank(get(handles.edit9,'String')));
LON2=str2num(deblank(get(handles.edit10,'String')));
LATINCR=str2num(deblank(get(handles.edit11,'String')));
LONINCR=str2num(deblank(get(handles.edit12,'String')));
DATEINCR=str2num(deblank(get(handles.edit15,'String')));

DIRNAME =deblank(get(handles.edit13,'String'));
if isempty(DIRNAME) DIRNAME=''; end
FNPREFIX=deblank(get(handles.edit14,'String'));

SaveWorkspace='n'; 
if get(handles.radiobutton1,'Value') == 1 SaveWorkspace='y'; end
SaveFiles='n'; 
if get(handles.radiobutton2,'Value') == 1 SaveFiles='y'; end

Fields={'sst','n';'sst4','n';'qual','n';'sdev','n';'num','n';'flag1','n';'flag2','n';'cflag','n'};
if get(handles.checkbox1,'Value')==1 Fields{1,2}='y'; end
if get(handles.checkbox2,'Value')==1 Fields{2,2}='y'; end
if get(handles.checkbox3,'Value')==1 Fields{3,2}='y'; end
if get(handles.checkbox4,'Value')==1 Fields{4,2}='y'; end
if get(handles.checkbox5,'Value')==1 Fields{5,2}='y'; end
if get(handles.checkbox6,'Value')==1 Fields{6,2}='y'; end
if get(handles.checkbox7,'Value')==1 Fields{7,2}='y'; end
if get(handles.checkbox8,'Value')==1 Fields{8,2}='y'; end

ApplyLandMask='n';
%if get(handles.checkbox44 ,'Value')==1 ApplyLandMask='y'; end

ApplyQualMask='n';
%if get(handles.checkbox33 ,'Value')==1 
%S=get(handles.popupmenu11,'String');j=get(handles.popupmenu11,'Value');
%ApplyQualMask=S{j}(3); %'n','4','7'
%end

CalcAnomaly='n';
%if get(handles.checkbox7 ,'Value')==1 CalcAnomaly='y'; end

S=get(handles.popupmenu1,'String');j=get(handles.popupmenu1,'Value');
TAVG=deblank(S{j});
S=get(handles.popupmenu2,'String');j=get(handles.popupmenu2,'Value');
HRES=deblank(S{j});

Platform={'terra','n';'aqua','n'}; 
if get(handles.radiobutton3,'Value') == 1 Platform{1,2}='y'; end % terra
if get(handles.radiobutton4,'Value') == 1 Platform{2,2}='y'; end % aqua
Pass={'day','n';'night','n'};
if get(handles.radiobutton5,'Value') == 1 Pass{1,2}='y'; end % day
if get(handles.radiobutton6,'Value') == 1 Pass{2,2}='y'; end % night

S=get(handles.popupmenu3,'String');j=get(handles.popupmenu3,'Value');
SaveWorkspaceMode=deblank(S{j});

%% Get default command line output from handles structure
R.DATE1=DATE1;
R.DATE2=DATE2;
R.DATEINCR=DATEINCR;
R.LAT1=LAT1;
R.LAT2=LAT2;
R.LATINCR=LATINCR;
R.LON1=LON1;
R.LON2=LON2;
R.LONINCR=LONINCR;
R.Fields=Fields;
R.Platform=Platform;
R.Pass=Pass;
R.TAVG=TAVG;
R.HRES=HRES;
R.ApplyLandMask=ApplyLandMask;
R.ApplyQualMask=ApplyQualMask;
R.CalcAnomaly=CalcAnomaly;
R.SaveWorkspace=SaveWorkspace;
R.SaveWorkspaceMode=SaveWorkspaceMode;
R.SaveFiles=SaveFiles;
R.DIRNAME=DIRNAME;
R.FNPREFIX=FNPREFIX;
%R.requestDate=datestr(now);
request=R;
handles.request=request;
   
% Load Last request
function pushbutton5_Callback(hObject, eventdata, handles)
pname = strrep(mfilename('fullpath'),mfilename,'');
fname = [mfilename,'_request','.mat'];
if exist([pname,fname],'file')
load([pname,fname])
else
msgbox(['File ',pname,fname,' does not exist.']);
end   

R=request;
DATE1=R.DATE1;
DATE2=R.DATE2;
DATEINCR=R.DATEINCR;
LAT1=R.LAT1;
LAT2=R.LAT2;
LATINCR=R.LATINCR;
LON1=R.LON1;
LON2=R.LON2;
LONINCR=R.LONINCR;
Fields=R.Fields;
Platform=R.Platform;
Pass=R.Pass;
TAVG=R.TAVG;
HRES=R.HRES;
ApplyLandMask=R.ApplyLandMask;
ApplyQualMask=R.ApplyQualMask;
CalcAnomaly=R.CalcAnomaly;
SaveWorkspace=R.SaveWorkspace;
SaveWorkspaceMode=R.SaveWorkspaceMode;
SaveFiles=R.SaveFiles;
DIRNAME=R.DIRNAME;
FNPREFIX=R.FNPREFIX;

% select only checked variables
[L1,L2]=size(Fields);
for k=1:L1
    eval(['set(handles.checkbox' num2str(k) ',''Value'',0)'])
    if Fields{k,2}=='y';
        eval(['set(handles.checkbox' num2str(k) ',''Value'',1)']) 
    end
end

% get strings from GUI menu and convert them to numbers
set(handles.edit1,'String',DATE1(1:4));
set(handles.edit2,'String',DATE1(5:6)); 
set(handles.edit3,'String',DATE1(7:8)); 
set(handles.edit4,'String',DATE2(1:4));
set(handles.edit5,'String',DATE2(5:6)); 
set(handles.edit6,'String',DATE2(7:8)); 
set(handles.edit7,'String',num2str(LAT1));
set(handles.edit8,'String',num2str(LAT2));
set(handles.edit9,'String',num2str(LON1));
set(handles.edit10,'String',num2str(LON2));
set(handles.edit11,'String',num2str(LATINCR));
set(handles.edit12,'String',num2str(LONINCR));
set(handles.edit13,'String',DIRNAME);
set(handles.edit14,'String',FNPREFIX);
set(handles.edit15,'String',num2str(DATEINCR));

S=get(handles.popupmenu1,'String');
j=find(strcmp(S,TAVG));
set(handles.popupmenu1,'Value',j);

S=get(handles.popupmenu2,'String');
j=find(strcmp(S,HRES));
set(handles.popupmenu2,'Value',j);

set(handles.radiobutton3,'Value',0);
set(handles.radiobutton4,'Value',0);
set(handles.radiobutton5,'Value',0);
set(handles.radiobutton6,'Value',0);
if Platform{1,2}=='y' set(handles.radiobutton3,'Value',1); end
if Platform{2,2}=='y' set(handles.radiobutton4,'Value',1); end
if Pass{1,2}=='y'     set(handles.radiobutton5,'Value',1); end
if Pass{2,2}=='y'     set(handles.radiobutton6,'Value',1); end

set(handles.radiobutton1,'Value',0);
if SaveWorkspace=='y'
    set(handles.radiobutton1,'Value',1); 
end
set(handles.radiobutton2,'Value',0);
if SaveFiles=='y'
    set(handles.radiobutton2,'Value',1); 
end

S=get(handles.popupmenu3,'String');
j=find(strcmp(S,SaveWorkspaceMode));
if isempty(j) j=1; end
set(handles.popupmenu3,'Value',j);

SaveFilesOnOff(hObject, eventdata, handles)

function SaveFilesOnOff(hObject, eventdata, handles)   
if get(handles.radiobutton2,'Value') == 0
    set(handles.edit13,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
    set(handles.edit14,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
elseif get(handles.radiobutton2,'Value') == 1
    set(handles.edit13,'BackgroundColor',[1. 1. 1.],'Enable','On')
    set(handles.edit14,'BackgroundColor',[1. 1. 1.],'Enable','On')
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%