function varargout = gui_pathfinder1km(varargin)
% Boots-up Pathfinder1km GUI, interacts with user via interface.
% gui_pathfinder1km M-file for gui_pathfinder1km.fig
%
% INPUT(S):
%
%   [none]
%
% OUTPUT(S):
%
%   h -- (optional) GUI handle
%
% OPeNDAP Science Team
% Copyright 2007, 2008
% $Version 2.0.0$

%==========================================================================
% Meri Sheremet
% September 2007
%
% REVISION HISTORY:
% 2007/09/25 created
% 2008/06/15 modified for compiled version, ceb
%==========================================================================

% Last Modified by GUIDE v2.5 21-Feb-2008 13:27:05

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_pathfinder1km_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_pathfinder1km_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before gui_pathfinder1km is made visible.
function gui_pathfinder1km_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to gui_pathfinder1km (see VARARGIN)

% Define handles "openfigure" field.
if ~isfield(handles,'openfigure')
    GetDataSetRanges
    handles.openfigure = 0; %set equal to zero on the first time.
end

% Set interface name.
filename = 'get_pathfinder1km';
txt = ['NASA/REASoN Ocean Data Portal - '];
tmp1 = ['Pathfinder1km GUI'];
tmp2 = '';
txt = [txt,tmp1];
if (~isdeployed)
    tmp2 = strrep(op_version('mfile',filename),'Version ','');
    txt = [txt,' (Ver ',tmp2,')'];
end
set(hObject,'Name',txt);

% % Set Version Number.
% filename = strrep(mfilename,'gui','get');
% info = op_version(filename);
% set(handles.text2,'String',info);

% Place logos on the GUI
% determine screen resolution and size of character in pixels
Units0=get(0,'Units'); % save initial settings
set(0,'Units','characters');
SSC=get(0,'ScreenSize'); % screen size in characters
set(0,'Units','pixels');
SSP=get(0,'ScreenSize'); % screen size in pixels
set(0,'Units',Units0); % restore to original units
ppcx=SSP(3)/SSC(3); % pixels per character along x
ppcy=SSP(4)/SSC(4); % pixels per character along y

[img,MAP]=imread('logo_opendap.jpg');
[NY,NX,N3]=size(img);
CX=(NX+8)/ppcx;         % button size in characters including 4 pixel grace margin
CY=(NY+12)/ppcy;
set(handles.pushbutton6,'CData',img)
pos = get(handles.pushbutton6,'position'); %units will be in characters
set(handles.pushbutton6,'position',[pos(1),pos(2),CX,CY]);

[img,MAP]=imread('logo_nasa1.jpg');
[NY,NX,N3]=size(img);
CX=(NX+8)/ppcx;         % button size in characters including 4 pixel grace margin
CY=(NY+12)/ppcy;
set(handles.pushbutton7,'CData',img)
pos = get(handles.pushbutton7,'position'); %units will be in characters
set(handles.pushbutton7,'position',[pos(1),pos(2),CX,CY]);  

[img,MAP]=imread('logo_gso.jpg');
[NY,NX,N3]=size(img);
CX=(NX+8)/ppcx;
CY=(NY+12)/ppcy;
set(handles.pushbutton4,'CData',img)
pos = get(handles.pushbutton4,'position'); %units will be in characters
set(handles.pushbutton4,'position',[pos(1),pos(2),CX,CY]);

[img,MAP]=imread('logo_gso_uri.jpg');
[NY,NX,N3]=size(img);
CX=(NX+8)/ppcx;
CY=(NY+12)/ppcy;
set(handles.pushbutton3,'CData',img)
pos = get(handles.pushbutton3,'position'); %units will be in characters
set(handles.pushbutton3,'position',[pos(1),pos(2),CX,CY]);

set(handles.edit11,'String',num2str(1));
set(handles.edit12,'String',num2str(1));
set(handles.edit13,'String',num2str(1));

txt=['Help'];
op_tooltipwrap(handles.pushbutton9,txt,50);

[img,MAP]=imread('logo_questionmark.jpg');
% [NY,NX,N3]=size(img);
% CX=(NX+8)/ppcx;
% CY=(NY+12)/ppcy;
% set(handles.pushbutton10,'CData',img)
% pos = get(handles.pushbutton10,'position'); %units will be in characters
% set(handles.pushbutton10,'position',[pos(1),pos(2),CX,CY]);
[N1,N2,N3]=size(img);
set(handles.pushbutton9,'string','')
set(handles.pushbutton9,'CData',img)
set(handles.pushbutton9,'Units','pixels')
pos = get(handles.pushbutton9,'position');
set(handles.pushbutton9,'position',[pos(1) pos(2) N1 N2])

if get(handles.checkbox1,'Value')==0 
set(handles.checkbox1,'Value',1)
end
handles.request.DecRaw='Dec';

if get(handles.radiobutton3,'Value')==0 & get(handles.radiobutton4,'Value')==0
set(handles.radiobutton3,'Value',1)
end

if get(handles.radiobutton4,'Value') == 0
    set(handles.edit14,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
    set(handles.edit15,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
elseif get(handles.radiobutton4,'Value') == 1
    set(handles.edit14,'BackgroundColor',[1. 1. 1.],'Enable','On')
    set(handles.edit15,'BackgroundColor',[1. 1. 1.],'Enable','On')
end

% Make 'Load Last Request' button inactive when file gui_xxx_request.mat is
% absent.
if ~exist('gui_pathfinder1km_request.mat','file') 
    set(handles.pushbutton5,'Enable','Off')
end

S=get(handles.popupmenu1,'String');j=get(handles.popupmenu1,'Value');
Region=deblank(S{j});
handles.request.Region=Region;
DataSet=LoadRanges(Region);

set(handles.text7,'String',['Available time range:  [' DataSet.Time(1,1:10) ' to ' DataSet.Time(end,1:10) ']'])
% Note: Latitude array in the DataSet runs from North to South
set(handles.text15,'String',['Available latitude range: [' num2str(DataSet.Latitude(end)) ' to ' num2str(DataSet.Latitude(1)) ']'])
set(handles.text19,'String',['Available longitude range: [' num2str(DataSet.Longitude(1)) ' to ' num2str(DataSet.Longitude(end)) ']'])

set(handles.pushbutton1,'String','Get Data','BackgroundColor',[0 1. 0.25])

SaveFilesOnOff(hObject, eventdata, handles)

% Update handles "openfigure" field.
handles.openfigure = 1;

% Choose default command line output for gui_pathfinder1km
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes gui_pathfinder1km wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = gui_pathfinder1km_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

function checkbox1_Callback(hObject, eventdata, handles)
function checkbox2_Callback(hObject, eventdata, handles)
function popupmenu1_Callback(hObject, eventdata, handles)
S=get(handles.popupmenu1,'String');j=get(handles.popupmenu1,'Value');
Region=deblank(S{j});
handles.request.Region=Region;
DataSet=LoadRanges(Region);
set(handles.text7,'String',['Available time range: [' DataSet.Time(1,1:10) ' to ' DataSet.Time(end,1:10) ']'])
% Note: Latitude array in the DataSet runs from North to South
set(handles.text15,'String',['Available latitude range: [' num2str(DataSet.Latitude(end)) ' to ' num2str(DataSet.Latitude(1)) ']'])
set(handles.text19,'String',['Available longitude range: [' num2str(DataSet.Longitude(1)) ' to ' num2str(DataSet.Longitude(end)) ']'])
% Update handles structure
guidata(hObject, handles);

function popupmenu1_CreateFcn(hObject, eventdata, handles)
%function popupmenu2_Callback(hObject, eventdata, handles)
%function popupmenu2_CreateFcn(hObject, eventdata, handles)
function radiobutton1_Callback(hObject, eventdata, handles)
function radiobutton2_Callback(hObject, eventdata, handles)
function edit1_Callback(hObject, eventdata, handles)
function edit1_CreateFcn(hObject, eventdata, handles)
function edit2_Callback(hObject, eventdata, handles)
function edit2_CreateFcn(hObject, eventdata, handles)
function edit3_Callback(hObject, eventdata, handles)
function edit3_CreateFcn(hObject, eventdata, handles)
function edit4_Callback(hObject, eventdata, handles)
function edit4_CreateFcn(hObject, eventdata, handles)
function edit5_Callback(hObject, eventdata, handles)
function edit5_CreateFcn(hObject, eventdata, handles)
function edit6_Callback(hObject, eventdata, handles)
function edit6_CreateFcn(hObject, eventdata, handles)
function edit7_Callback(hObject, eventdata, handles)
function edit7_CreateFcn(hObject, eventdata, handles)
function edit8_Callback(hObject, eventdata, handles)
function edit8_CreateFcn(hObject, eventdata, handles)
function edit9_Callback(hObject, eventdata, handles)
function edit9_CreateFcn(hObject, eventdata, handles)
function edit10_Callback(hObject, eventdata, handles)
function edit10_CreateFcn(hObject, eventdata, handles)
function edit11_Callback(hObject, eventdata, handles)
function edit11_CreateFcn(hObject, eventdata, handles)
function edit12_Callback(hObject, eventdata, handles)
function edit12_CreateFcn(hObject, eventdata, handles)
function edit13_Callback(hObject, eventdata, handles)
function edit13_CreateFcn(hObject, eventdata, handles)
function edit14_Callback(hObject, eventdata, handles)
function edit14_CreateFcn(hObject, eventdata, handles)
function edit15_Callback(hObject, eventdata, handles)
function edit15_CreateFcn(hObject, eventdata, handles)
function radiobutton3_Callback(hObject, eventdata, handles)
function radiobutton4_Callback(hObject, eventdata, handles)
if get(handles.radiobutton4,'Value') == 0
    set(handles.edit14,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
    set(handles.edit15,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
elseif get(handles.radiobutton4,'Value') == 1
    set(handles.edit14,'BackgroundColor',[1. 1. 1.],'Enable','On')
    set(handles.edit15,'BackgroundColor',[1. 1. 1.],'Enable','On')
end
function popupmenu3_Callback(hObject, eventdata, handles)
S=get(handles.popupmenu3,'String');j=get(handles.popupmenu3,'Value');
R.SaveMode=S{j};
% disable saving to workspace for netcdf mode
set(handles.radiobutton3,'Enable','On');
if strcmp(R.SaveMode,'netcdf')
    set(handles.radiobutton3,'Value',0,'Enable','Off');
    set(handles.radiobutton4,'Value',1);
end

function popupmenu3_CreateFcn(hObject, eventdata, handles)
function pushbutton2_Callback(hObject, eventdata, handles)
if get(handles.radiobutton4,'Value') == 1
DIRNAME=uigetdir(pwd,'Select a Directory for Downloading Files');
set(handles.edit14,'String',DIRNAME)
end

% The main button that starts data acquisition
function pushbutton1_Callback(hObject, eventdata, handles)
% uiresume(handles.figure1)

% Turn off ability to re-issue "Get Data."
set(hObject,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off','String','Please wait...');
pause(.1)

% Get input from user.
request=InputGet(hObject, eventdata, handles);

% Save request to .mat file.
filename = 'gui_pathfinder1km_request.mat';
if (~isdeployed)
    pname = mfilename('fullpath');
    pname = pname(1:length(pname)-length(mfilename)); %mfilename does not have .m in it
    filename = [pname,filename];
end
save(filename,'request','-mat')
set(handles.pushbutton5,'Enable','On')

% If it passes inspection, send down to user's workspace
% as variable "request". Then the user can get the data
%assignin('base','request',request);

get_pathfinder1km(request);

set(hObject,'Enable','On','String','Get Data','BackgroundColor',[0 1. 0.25])

function request=InputGet(hObject, eventdata, handles)
S1=deblank(get(handles.edit1,'String'));
S2=deblank(get(handles.edit2,'String'));
S3=deblank(get(handles.edit3,'String'));
S4=deblank(get(handles.edit4,'String'));
S5=deblank(get(handles.edit5,'String'));
S6=deblank(get(handles.edit6,'String'));

R.DATE1='00000000';
R.DATE1(4-length(S1)+1:4)=S1;
R.DATE1(6-length(S2)+1:6)=S2;
R.DATE1(8-length(S3)+1:8)=S3;
R.DATE2='00000000';
R.DATE2(4-length(S4)+1:4)=S4;
R.DATE2(6-length(S5)+1:6)=S5;
R.DATE2(8-length(S6)+1:8)=S6;

R.LAT1=str2num(deblank(get(handles.edit7,'String')));
R.LAT2=str2num(deblank(get(handles.edit8,'String')));
R.LON1=str2num(deblank(get(handles.edit9,'String')));
R.LON2=str2num(deblank(get(handles.edit10,'String')));

R.DATEINCR=str2num(deblank(get(handles.edit11,'String')));
R.LATINCR=str2num(deblank(get(handles.edit12,'String')));
R.LONINCR=str2num(deblank(get(handles.edit13,'String')));

R.Fields={
    'sst_declouded','n','Dec';
    'sst_raw'      ,'n','Raw'}; %'bsst','n';'sdev','n';'msk1','n';'msk2','n';'num','n';'qual','n'};
if get(handles.checkbox1 ,'Value')==1 R.Fields{1,2}='y'; end
if get(handles.checkbox2 ,'Value')==1 R.Fields{2,2}='y'; end

%ApplyLandMask='n';
%if get(handles.checkbox4 ,'Value')==1 ApplyLandMask='y'; end
%if get(handles.checkbox15 ,'Value')==1 ApplyLandMask='y'; end

%ApplyQualMask='n';
%if get(handles.checkbox14 ,'Value')==1 
%S=get(handles.popupmenu1,'String');j=get(handles.popupmenu1,'Value');
%ApplyQualMask=S{j}(3); %'n','4','7'
%end

S=get(handles.popupmenu1,'String');j=get(handles.popupmenu1,'Value');
R.Region=deblank(S{j});
%S=get(handles.popupmenu2,'String');
%j=get(handles.popupmenu2,'Value');
%R.TAvg=deblank(S{j})
R.TAvg='daily';%deblank(S); % only one value

R.Pass={'night','n';'day','n'}; % night and/or day passes
if get(handles.radiobutton1,'Value') == 1 R.Pass{1,2}='y'; end
if get(handles.radiobutton2,'Value') == 1 R.Pass{2,2}='y'; end    

S=get(handles.popupmenu3,'String');j=get(handles.popupmenu3,'Value');
R.SaveMode=deblank(S{j});
R.SaveWorkspace='n'; 
if get(handles.radiobutton3,'Value') == 1 R.SaveWorkspace='y'; end
R.SaveFiles='n'; 
if get(handles.radiobutton4,'Value') == 1 R.SaveFiles='y'; end
R.DIRNAME =deblank(get(handles.edit14,'String'));
if isempty(R.DIRNAME) R.DIRNAME=''; end
R.FNPREFIX=deblank(get(handles.edit15,'String'));

%% Get default command line output from handles structure.   
% R.RequestDate=datestr(now,'yyyy-mm-dd HH:MM:SS');
request=R;

function pushbutton4_Callback(hObject, eventdata, handles)
%web 'http://satdat1.gso.uri.edu/opendap/reason/pathfinder1km/pathfinder_1km.html' -browser
web 'http://satdat1.gso.uri.edu/opendap/Pathfinder/Pathfinder1km/pathfinder_1km.html' -browser
function pushbutton6_Callback(hObject, eventdata, handles)
web 'http://www.opendap.org/' -browser
function pushbutton7_Callback(hObject, eventdata, handles)
%web 'http://www.nasa.gov/topics/earth/index.html' -browser
web 'http://www.nasa.gov' -browser
function pushbutton3_Callback(hObject, eventdata, handles)
web 'http://satdat1.gso.uri.edu/opendap/Pathfinder/' -browser

% Load Last request
function pushbutton5_Callback(hObject, eventdata, handles)

filename = 'gui_pathfinder1km_request.mat';
if exist(filename,'file')
    load(filename)
else
    msgbox(['File ',filename,' does not exist.']);
    return
end

R=request;

set(handles.edit1,'String',R.DATE1(1:4));
set(handles.edit2,'String',R.DATE1(5:6)); 
set(handles.edit3,'String',R.DATE1(7:8)); 
set(handles.edit4,'String',R.DATE2(1:4));
set(handles.edit5,'String',R.DATE2(5:6)); 
set(handles.edit6,'String',R.DATE2(7:8)); 
set(handles.edit7,'String',num2str(R.LAT1));
set(handles.edit8,'String',num2str(R.LAT2));
set(handles.edit9,'String',num2str(R.LON1));
set(handles.edit10,'String',num2str(R.LON2));
set(handles.edit11,'String',num2str(R.DATEINCR));
set(handles.edit12,'String',num2str(R.LATINCR));
set(handles.edit13,'String',num2str(R.LONINCR));

set(handles.checkbox1 ,'Value',0); 
set(handles.checkbox2 ,'Value',0); 
if R.Fields{1,2}=='y' set(handles.checkbox1 ,'Value',1); end
if R.Fields{2,2}=='y' set(handles.checkbox2 ,'Value',1); end

% might need in the future
%if R.ApplyLandMask=='y' set(handles.checkbox4 ,'Value',1); end
%if R.ApplyLandMask=='y' set(handles.checkbox15 ,'Value',1); end

%R.ApplyQualMask=S{j}(3); %'n','4','7'
%R.ApplyQualMask;
%S=get(handles.popupmenu1,'String');
%S=strvcat(S);
%j=strfind(S(:,3)',R.ApplyQualMask);
%if ~isempty(j) 
%    set(handles.checkbox14 ,'Value',1); 
%    set(handles.popupmenu1,'Value',j);
%else
%    set(handles.checkbox14 ,'Value',0);
%end

S=get(handles.popupmenu1,'String');
j=find(strcmp(S,R.Region));
if isempty(j) j=1; end
set(handles.popupmenu1,'Value',j);

%S=get(handles.popupmenu2,'String');
%j=find(strcmp(S,R.TAvg));
%if isempty(j) j=1; end
%set(handles.popupmenu2,'Value',j);
%set(handles.popupmenu2,'String',R.TAvg);

set(handles.radiobutton1,'Value',0);
set(handles.radiobutton2,'Value',0);
if R.Pass{1,2}=='y' set(handles.radiobutton1,'Value',1); end
if R.Pass{2,2}=='y' set(handles.radiobutton2,'Value',1); end
set(handles.radiobutton3,'Value',0);
set(handles.radiobutton4,'Value',0);

S=get(handles.popupmenu3,'String');
j=find(strcmp(S,R.SaveMode));
if isempty(j) j=1; end
set(handles.popupmenu3,'Value',j);
if R.SaveWorkspace=='y' set(handles.radiobutton3,'Value',1); end
if R.SaveFiles=='y' set(handles.radiobutton4,'Value',1); end
set(handles.edit14,'String',R.DIRNAME);
set(handles.edit15,'String',R.FNPREFIX);

S=get(handles.popupmenu3,'String');j=get(handles.popupmenu3,'Value');
R.SaveMode=S{j};
% disable saving to workspace for netcdf mode
set(handles.radiobutton3,'Enable','On');
if strcmp(R.SaveMode,'netcdf')
    set(handles.radiobutton3,'Value',0,'Enable','Off');
    set(handles.radiobutton4,'Value',1);
end

SaveFilesOnOff(hObject, eventdata, handles)

DataSet=LoadRanges(R.Region);

set(handles.text7,'String',['Available time range: [' DataSet.Time(1,1:10) ' to ' DataSet.Time(end,1:10) ']'])
% Note: Latitude array in the DataSet runs from North to South
set(handles.text15,'String',['Available latitude range: [' num2str(DataSet.Latitude(end)) ' to ' num2str(DataSet.Latitude(1)) ']'])
set(handles.text19,'String',['Available longitude range: [' num2str(DataSet.Longitude(1)) ' to ' num2str(DataSet.Longitude(end)) ']'])

%handles;
% Update handles structure
guidata(hObject, handles);

function SaveFilesOnOff(hObject, eventdata, handles)   
if get(handles.radiobutton4,'Value') == 0
    set(handles.edit14,'BackgroundColor',[0.878 0.875 0.891],'Enable','Off')
    set(handles.edit15,'BackgroundColor',[0.878 0.875 0.891],'Enable','Off')
elseif get(handles.radiobutton4,'Value') == 1
    set(handles.edit14,'BackgroundColor',[1. 1. 1.],'Enable','On')
    set(handles.edit15,'BackgroundColor',[1. 1. 1.],'Enable','On')
end

% function DataSet=LoadRanges(Region)
% if ~exist('gui_pathfinder1km_dataset.mat','file') 
%     errordlg(['File gui_pathfinder1km_dataset.mat does not exist.',...
%         'Click Get Data again.']);
%     return
% end
% load gui_pathfinder1km_dataset.mat
% if strcmp(Region,'Northwest Atlantic') DS=['NWAtlantic']; end
% if strcmp(Region,'Northeast Pacific' ) DS=['NEPacific']; end
% if strcmp(Region,'Northwest Pacific' ) DS=['NWPacific']; end
% eval(['DataSet=DS' DS ';'])

function pushbutton9_Callback(hObject, eventdata, handles)
h = op_timemessage('polar',0);

function GetDataSetRanges
h=msgbox('Acquiring metadata from Pathfinder1km site, please wait ...');
% next line makes OK button invisible
hh=get(h,'Children'); set(hh(2),'Visible','off'); pause(1);
% individual addresses
%URL=['http://satdat1.gso.uri.edu/thredds/dodsC/NWAtlantic' 'Dec' '_1km'];
%URL=['http://satdat1.gso.uri.edu/thredds/dodsC/NWAtlantic' 'Raw' '_1km']; 
%URL=['http://satdat1.gso.uri.edu/thredds/dodsC/NEPacific'  'Dec' '_1km'];  
%URL=['http://satdat1.gso.uri.edu/thredds/dodsC/NEPacific'  'Raw' '_1km'];  
%URL=['http://satdat1.gso.uri.edu/thredds/dodsC/NWPacific'  'Dec' '_1km'];  
%URL=['http://satdat1.gso.uri.edu/thredds/dodsC/NWPacific'  'Raw' '_1km'];
LRegion={'NWAtlantic';'NEPacific';'NWPacific'};
for kR=1:length(LRegion)
URL=['http://satdat1.gso.uri.edu/thredds/dodsC/' LRegion{kR} 'Dec' '_1km'];
loaddap('+v',[URL '?lat,lon,time']);
if ~exist('time','var')
    error('The server is not working properly. Please try again later.')
end
Time70Dec=round(time);
URL=['http://satdat1.gso.uri.edu/thredds/dodsC/' LRegion{kR} 'Raw' '_1km'];
loaddap([URL '?lat,lon,time']);
Time70Raw=round(time);
% merge two time arrays with possible gaps
[Time70,iDec,iRaw]=mergeint(Time70Dec,Time70Raw);
user_friendly_time=datestr(datenum(1970,1,1,0,0,0)+Time70/86400,'yyyy-mm-dd HH:MM:SS'); % Gregorian, char array 

DataSet.Name='Pathfinder1km';
DataSet.Region=LRegion{kR};
DataSet.Latitude=lat;
DataSet.Longitude=lon;
DataSet.Time70=time;
DataSet.Time=user_friendly_time;
DataSet.iDec=iDec;
DataSet.iRaw=iRaw;
eval(['DS' LRegion{kR} '=DataSet;']);
end
close(h)

%save gui_pathfinder1km_dataset.mat DSNWAtlantic DSNEPacific DSNWPacific
filename = 'gui_pathfinder1km_dataset.mat';
if (~isdeployed)
    pname = strrep(mfilename('fullpath'),mfilename,'');
    filename = strcat(pname,filename);
end
save(filename,'DSNWAtlantic','DSNEPacific','DSNWPacific','-mat')

function [c,pa,pb]=mergeint(a,b)
% [c,pa,pb]=mergeint(a,b) 
%           merges two integer arrays with gaps
% input:    a, b arrays to be merged
% output:   c merged array containing all possible values in a and b without repetition
%           pa,pb index pointers to original arrays a and b; NaN if the value is not available 
%
% Example:
% a=[010;020;030;050;060;070;080;090;100];
% b=[030;040;060;070;080;090;100;120];
% c=[10;20;30;40;50;60;70;80;90;100;120];
% pa=[     1     2     3   NaN     4     5     6     7     8     9   NaN]';
% pb=[   NaN   NaN     1     2   NaN     3     4     5     6     7     8]';


[NA,N2]=size(a);
[NB,N2]=size(b);
NC=NA+NB;
c=[a;b];pa=c;pb=c;
ka=1;kb=1;kc=0;

while ka<=NA | kb<=NB
if ka<=NA & kb<=NB
    if a(ka)==b(kb)
    kc=kc+1;c(kc)=a(ka);pa(kc)=ka;pb(kc)=kb;ka=ka+1;kb=kb+1;
    elseif a(ka)<b(kb)
    kc=kc+1;c(kc)=a(ka);pa(kc)=ka;pb(kc)=NaN;ka=ka+1;
    elseif a(ka)>b(kb)
    kc=kc+1;c(kc)=b(kb);pa(kc)=NaN;pb(kc)=kb;kb=kb+1;
    end
elseif ka>NA & kb<=NB
    kc=kc+1;c(kc)=b(kb);pa(kc)=NaN;pb(kc)=kb;kb=kb+1;
elseif ka<=NA & kb>NB
    kc=kc+1;c(kc)=a(ka);pa(kc)=ka;pb(kc)=NaN;ka=ka+1;
end
end
NC=kc;
c=c(1:NC);
pa=pa(1:NC);
pb=pb(1:NC);

function DataSet=LoadRanges(Region)
if ~exist('gui_pathfinder1km_dataset.mat','file') 
    errordlg(['File gui_pathfinder1km_dataset.mat does not exist.',...
        'Reissue ',mfilename,'.']);
    return
end
load gui_pathfinder1km_dataset.mat
if strcmp(Region,'Northwest Atlantic') DS=['NWAtlantic']; end
if strcmp(Region,'Northeast Pacific' ) DS=['NEPacific' ]; end
if strcmp(Region,'Northwest Pacific' ) DS=['NWPacific' ]; end
eval(['DataSet=DS' DS ';'])